avl:		/* PROGRAM TO CREAT AVL TREE.
		   Program uses enumerated data type to indicate
		   lefthigh,right high, or equal.
		   Program by: Mrs. Shivangi G. Potdar        */


	# include<stdio.h>
	# include<conio.h>
	# include<stdlib.h>
	# include<string.h>

typedef enum balancefactor_tag{lh,eh,rh} balancefactor_type;

int *taller;

struct node                           /* declaring structure of each node*/
{
	char name[10];
	balancefactor_type bf;
	struct node *left , *right;
};

struct node *root , *p , *q;
/*--------------End of declarations -------------------------------*/

struct node *insert(struct node *root,struct node *p, int *taller);
void inorder(struct node * );
struct node *leftrotate(struct node *p);
struct node *rightrotate(struct node *p);
struct node *leftbalance(struct node *root, int *taller);
struct node *rightbalance(struct node *root, int *taller);

/*------------------Function prototypes-------------------------*/

	void main(void)
	{
	  char ans;
	  int ch1=1;
	  *taller = 0;      /* intialize height and root of the tree*/
	  root = NULL;
	  while( ch1!=3)
	  {
		clrscr();
		printf("\n\n\t\t ***** MENU ****\n");
		printf("\n\t\t 1. ADD ELEMENTS ");
		printf("\n\t\t 2. INORDER ");
		printf("\n\t\t 3. Exit ");
		scanf("%d", &ch1);
		clrscr();
		switch(ch1)
		{
			case 1 :do{
				   p = malloc(sizeof(struct node));
				   printf("\n\t\tENTER THE NAME OT BE ADDED ");
				   scanf("%s", p->name);
				p->right = NULL;
				p->left = NULL;
				root = insert(root,p,taller);
				printf("\n Add one more ? ");
				ans=getch();
				  }while(ans=='y' || ans=='Y');
							break;
			case 2:
			     printf("\n\t\tINORDER TRAVERSAL\n\n");
			     printf("ROOT  =  %s\n\n",root->name);
			     printf(" TREE : ");
			     inorder(root);
			     getch();
			     break;
		}

	}
}

/*----------------------End of main--------------------------------*/

	void inorder(struct node *root)
	/* Function for inorder traversal */
	{
	  if(root != NULL)
	  {
		inorder(root->left);
		printf("\t%s", root->name);
		inorder(root->right);
	  }
	}
/*----------------End of function inorder-------------------------*/

	struct node *insert(struct node *root,struct node *p, int *taller)
	/* function to add new node in AVL tree in proper position */
	{
	if(!root)
	{
		root = p;
		root->bf = eh;
		root->left = root->right = NULL;
		*taller = 1;
	}
	else
	 if(strcmp(root->name,p->name) == 0)
	    printf("\n\t\tDUPLICATION ERROR!!");
	else
	   if(strcmp(root->name,p->name)>0 )    /* if new node is smaller*/
	   {																					/*than the present root */
	    root->left = insert(root->left, p, taller);
	    if(*taller == 1)
		{
		  switch(root->bf)  /* perform balancing */
		  {
		    case lh :
			      root = leftbalance(root, taller);
			      break;

		    case eh :
			       root->bf = lh;
			       break;
		    case rh :
			       root->bf = eh;
			       *taller = 0;
			       break;
		  }
		}
	     }
	     else
		if(strcmp(root->name,p->name)<0 )   /* if new node is larger*/
		{																							/*greater than the root*/
		 root->right = insert(root->right, p, taller);
		 if(*taller == 1)
		 {
			switch(root->bf) /* adjust the heights */
			{
			  case lh :
				   root->bf = eh;
				   *taller = 0;
				   break;

			  case eh :
				   root->bf = rh;
				   break;

			  case rh :
				   root = rightbalance(root, taller);
				   break;
			}
		}
	     }
	     return(root);
	}
/*---------------------------End of function insert -----------------*/

	struct node *rightrotate(struct node *p)
	/* function for right rotation */
	{
	 struct node *temp;
	 if(p==NULL)        /* if tree is empty*/
		 printf("\n\t\tCANNOT ROTATE AN EMPTY TREE");
	 else
	   if(p->left == NULL)     /* if tree can be rotated right*/
		 printf("\n\t\tCANNOT ROTATE RIGHT");
	   else
	     {
		temp = p->left;          /* rotate right */
		p->left = temp->right;
		temp->right = p;
	     }
	 return(temp);
	}

/* THIS FUNCTION ROTATES THE TREE/SUBTREE AT 'p' ONCE TOWARDS LEFT */
struct node *leftrotate(struct node *p)
{
	 struct node *temp;
	 if(p==NULL)                       /* check if tree is empty */
	 printf("\n\t\tCANNOT ROTATE AN EMPTY TREE");
	 else if(p->right == NULL)        /* check if tree can be rotated left*/
	 printf("\n\t\tCANNOT ROTATE LEFT");
	 else
	 {
			temp = p->right;
			p->right = temp->left;        /* rotate left */
			temp->left = p;
	 }
	 return(temp);
	}
/*---------------------end of function rotate right-----------------*/

	/* FUNCTION TO BALANCE THE SUBTREE AT 'root' IF BALANCE FACTOR*/
	/* AT 'root' IS DOUBLE RIGHT HIGH */

	struct node *rightbalance(struct node *root, int *taller)
	{
	   struct node *rs = root->right, *ls;
		   /* ASSIGN rs TO RIGHT SUBTREE OF root*/
	   switch(rs->bf)
	   {
		case rh :
			 root->bf = rs->bf = eh;
			 root = leftrotate(root);
			 *taller = 0;
			 break;

		case eh :
			  printf("\n\tTREE ALREADY BALLANCED");
			  break;

		case lh :
			  ls = rs->left;
				 /* ASSIGN ls TO LEFT SUBTREE OF rs */
			  switch(ls->bf)
			    {
				case lh :
					root->bf = eh;
					rs->bf = rh;
					break;
				case eh :
					 root->bf = rs->bf = eh;
					 break;
				case rh :
					 root->bf = lh;
					 rs->bf = eh;
					 break;
			    }
			  ls->bf = eh;
			  root->right = rightrotate(rs);
			  root = leftrotate(root);
			  *taller = 0;
	   }
	   return(root);
	}
/*---------------------End of function  rightbalance---------------*/

	/* FUNCTION TO BALANCE THE SUBTREE AT 'root' IF BALANCE FACTOR*/
	/* AT 'root' IS DOUBLE LEFT HIGH */

	struct node *leftbalance(struct node *root, int *taller)
	{
	struct node *ls = root->left, *rs;
		    /*ASSIGN ls TO LEFT SUBTREE OF ROOT */

	    switch(ls->bf)
	    {
	      case lh :
		      root->bf = ls->bf = eh;
		      root = rightrotate( root);
		      *taller = 0;
		      break;

	      case eh :
		      printf("\n\tTREE ALREADY BALLANCED");
		      break;      /*  TREE IS ALREADY BALANCED */

	      case rh :
		      rs = ls->right; /*ASSIGN rs RIGHT SUBTREE OF ls*/
		      switch(rs->bf)
			{
			case rh :
				root->bf = eh;
				ls->bf = lh;
				break;
			case eh :
				root->bf = ls->bf = eh;
				break;
			case lh : root->bf = rh;
				 ls->bf = eh;
				 break;
			}
			rs->bf = eh;
			root->left = leftrotate(ls);
			root = rightrotate(root);
			*taller = 0;
	      }
	      return(root);
	}

/*----------------End of function leftbalance-----------------------*/