	/* Program to implement primitive operations on
	   indexed sequential files. The input record contains :

		name of student,
		rollnumber and
		three test scores.

		For simplicity we have taken roll number as the index.
	   However on must notice that we can find index on any record
	   fields using hash functions.

	   Program by : Mrs. Shivangi G. Potdar.			*/

/*----------------------------------------------------------------------*/
		/*Header Files*/
	#include<stdio.h>
	#include<conio.h>
	#include<stdlib.h>
	#include<string.h>

	/*structure declaration*/

	typedef struct record

	{
	  int roll,m1,m2,m3; /* m1,m2,m3 are the three test scores */
	  char name[30];
	}stud;

	FILE *fp,*ip;
	/*------------end of global variable declarations----------*/

	void display();
	void append();
	void create();
	void sort(FILE *);
	void display_one(stud ,int );
	void input_rec(FILE *);
	int search(char filename[]);
	void delete_rec(char filename[]);
	void index(char[]);
       /*----------Function prototype declaration ends------------*/

	main()
	{
	 char ans,filename[12];
	 int ch;
	 do
	 {
	   clrscr();
	   printf("\n\t\tINDEXED SEQUENTIAL FILE");
	   printf("\n\t 1>Create a file");
	   printf("\n\t 2>Add a record");
	   printf("\n\t 3>Delete a record");
	   printf("\n\t 4>Search for Record");
	   printf("\n\t 5>Display file");
	   printf("\n\t 6>Quit");
	   printf("\n\t\t Enter your choice");
	   scanf("%d",&ch);
	   switch(ch)
	   {
	     case 1 :
		    clrscr();
		    create();
		    break;
	     case 2 :
		    clrscr();
		    append();
		    break;
	     case 3 :
		     clrscr();
		     printf("\nEnter the filename\n");
		     flushall();
		     gets(filename);
		     delete_rec(filename);
		     break;
	     case 4 :
		     clrscr();
		     printf("\nEnter the filename\n");
		     flushall();
		     gets(filename);
		     search(filename);
		     break;
	     case 5 :
		     clrscr();
		     display();
		     break;
	     case 6 :
		     clrscr();
		     exit(1);
		     break;
	     default:
		     printf("\nEntered wrong choice\n");
		     break;
	   }
		printf("\nDo you want to continue?[y/n]");
		flushall();
		ans = getch();
	 }while(ans == 'y' || ans == 'Y');
	}
/*-----------------End of main function-----------------------------*/

	void create()
	/*Function to create a new file*/
	{
	 char filename[12];
	 printf("\n\tEnter the filename in which you wish to store data\n");
	 flushall();
	 gets(filename);
	 if((fp = fopen(filename,"wb")) == NULL)
	 {
		printf("ERROR in opening file in write mode");
		return;
	 }
	 input_rec(fp); /* get records in file */
	 fclose(fp);
	 if((fp = fopen(filename,"rb+")) == NULL)
	 {
		printf("Error in opening file in read mode");
		return;
	 }
	 sort(fp);
	 index(filename);
	}

/*------------End of function create---------------------------------*/

	void input_rec(FILE *fp)

	/*Accept data for record*/

	{
	 stud temp;
	 char ch;
	 int i = 1;
	 do
	 {
		clrscr();
		printf("\n\n\tRecord No. %d",i);
		printf("\n\n\tStudent Name :");
		fflush(stdin);
		gets(temp.name);
		printf("\n\n\tRoll number :");
		scanf("%d",&temp.roll);
		printf("\n\n\tMarks 1 :");
		scanf("%d",&temp.m1);
		printf("\n\n\tMarks 2 :");
		scanf("%d",&temp.m2);
		printf("\n\n\tMarks 3 :");
		scanf("%d",&temp.m3);
		fwrite(&temp,sizeof(stud),1,fp);
		i++;
		printf("\nDo you wish to continue adding records?[y/n]");
		flushall();
		ch = getch();

	 }while(ch == 'y' || ch == 'Y');

	}


/*---------------End of function input_rec---------------------------*/

	void index(char filename[])

	/*Function to create index*/

	{
	 int key;
	 stud temp;
	 if((fp = fopen(filename,"rb+")) == NULL)
	 {
		printf("\nError in opening file");
		return;
	 }
	 if((ip = fopen("index.file","wb")) == NULL)
	 {
		printf("\nError in opening file");
		return;
	 }
	 while(!feof(fp))
	 {
		fread(&temp,sizeof(stud),1,fp);
		key = temp.roll;
		fwrite(&key,sizeof(int),1,ip); /* store the index in
						index.file */
	}
	 fclose(fp);
	 fclose(ip);
	}

/*-------------------end of function index---------------------------*/

	void append()

	/*Appending the exisiting file*/

	{
	 char filename[12];
	 printf("\nEnter the filename\n");
	 flushall();
	 gets(filename);
	 if((fp = fopen(filename,"ab")) == NULL)
	 {
		printf("ERROR in opening file");
		return;
	 }
	 printf("\nAppending File");
	 getch();
	 input_rec(fp);
	 fclose(fp);
	 if((fp = fopen(filename,"rb+")) == NULL)
	 {
		printf("Error in opening file");
		return;
	 }
	 sort(fp);
	 index(filename);
	}

/*------------End of append function--------------------------------*/

	void display()

	/*displaying the file*/

	{
	 char filename[12];
	 int i = 1;
	 stud temp;
	 printf("\nEnter the filename\n");
	 flushall();
	 gets(filename);
	 if((fp = fopen(filename,"rb")) == NULL)
	 {
	   printf("\nError in opening file");
	   return;
	 }
            fread(&temp,sizeof(stud),1,fp);
	 while(!feof(fp))
	 {
	    clrscr();
	 
	    if(temp.roll != -1)
	    {
		printf("\nRecords of file '%s'",filename);
		printf("\n\n\tRecord   %d",i);
		printf("\n\n\tStudent Name : %s",temp.name);
		printf("\n\n\tRoll Number : %d",temp.roll);
		printf("\n\n\tMarks 1 : %d",temp.m1);
		printf("\n\n\tMarks 2 : %d",temp.m2);
		printf("\n\n\tMarks 3 : %d",temp.m3);
		i++;
		getch();
		printf("Enter to continue....");
	    }
	    else /* record not prsent at present position */
		i++;
                   fread(&temp,sizeof(stud),1,fp);
	    }
	  fclose(fp);
	}

/*---------------------------End of function DISPLAY----------------*/

	void sort(FILE *fp)

	/*sorting the records of file  according to index key roll number*/
	{
	 stud temp1, temp2;
	 int size = 0,i,j;
	 while(!feof(fp))
	 {
	   fread(&temp1,sizeof(stud),1,fp);
	   size++;
	 }
	 size= size-2;
	 for(i = 0;i < size+1;i++)      /*bubble sort of roll numbers*/
	 {
	  for(j = i+1;j < size+1;j++)
	   {
		fseek(fp,i*(sizeof(stud)),0);
		fread(&temp1,sizeof(stud),1,fp);
		fseek(fp,j*(sizeof(stud)),0);
		fread(&temp2,sizeof(stud),1,fp);
		if(temp1.roll > temp2.roll)
		{
		 fseek(fp,i*(sizeof(stud)),0);
		 fwrite(&temp2,sizeof(stud),1,fp);
		 fseek(fp,j*(sizeof(stud)),0);
		 fwrite(&temp1,sizeof(stud),1,fp);
		}
	    }
	  }
	   fclose(fp);
	}

/*----------------End of function sort------------------------------*/

	int search(char filename[])

	/*searching for required record*/

	{
	 int found=0,rno,key,pos = 0,kk;
	 stud temp;
	 if((fp = fopen(filename,"rb")) == NULL)
	 {
		printf("\nError in opening File");
		return;
	 }
	 printf("\nEnter The roll number of record to be found\n");
	 scanf("%d",&rno);
	 if((ip = fopen("index.file","rb")) == NULL)
	 {
	    printf("\nError in opening File");
	    return;
	 }
	 while((!found)&&(!feof(ip)))
	 {
		fread(&key,sizeof(int),1,ip);
		if(key == rno)  /* get the index for required key */
			found = 1;
		pos++;
	 }
	 pos--;
	 if(found == 1)
	 {
		fseek(fp,pos*(sizeof(stud)),0);
		fread(&temp,sizeof(stud),1,fp);
		display_one(temp,pos);
		return(pos);
	 }
	 else
	 {
		printf("\nRecord not found");
		 fclose(fp);
		 fclose(ip);
		return(-1);
	 }
	}
/*---------------End of search function-----------------------------*/

	void display_one(stud temp,int pos)

	/*display the record which "search" function has
	  found                  */

	{
	 clrscr();
	 printf("\n\n\tRecord   %d",pos);
	 printf("\n\n\tStudent Name : %s",temp.name);
	 printf("\n\n\tRoll Number : %d",temp.roll);
	 printf("\n\n\tMarks 1 : %d",temp.m1);
	 printf("\n\n\tMarks 2 : %d",temp.m2);
	 printf("\n\n\tMarks 3 : %d",temp.m3);
	 getch();
	 printf("Enter to continue....");
	}

/*---------------End of display function of single record------------*/

	void delete_rec(char filename[])

	 /*deleting a record*/

	{
	  stud temp;
	  int pos;
	  pos = search(filename);
	  if(pos == -1)
	  {
		printf("\nRecord not found");
		return;
	 }
	 else
	 {
		if((fp = fopen(filename,"rb+"))==NULL)
		{
			printf("\nError in opening file");
			return;
		}
		fseek(fp,pos*(sizeof(stud)),0);
		fread(&temp,sizeof(stud),1,fp);
		temp.roll = -1;                  /*logical deletion*/
		fseek(fp,pos*(sizeof(stud)),0);
		fwrite(&temp,sizeof(stud),1,fp);
		fclose(fp);

		printf("\nThe record has been successfully deleted\n");

		if((fp = fopen(filename,"rb+")) == NULL)
		{
			printf("Error in opening file");
			return;
		}
		sort(fp);
		index(filename);
	 }
	}

/*------------- end of function delete a record-----------------------*/



















