	/* Program to sort the numbers using MERGE SORT.
	   Use the arrow keys to select the option .
	   program by : Mrs Shivangi G. Potdar */

/* Including Header Files */
/* ---------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>

/* Defining The Macros For Choices */
/* ------------------------------- */

#define CH1 "1.Create The List"
#define CH2 "2.Sort The List  "
#define CH3 "3.Print The List "
#define CH4 "4.Exit           "
#define CHOICE(ch) ch==1?CH1:(ch==2?CH2:(ch==3?CH3:CH4))

/* Function Prototypes */
/* ------------------- */

void append(void);
void print(void);
struct list *sort(struct list *p);
struct list *divide(struct list *p);
struct list *merge(struct list *p,struct list *q);

/* Global Variable Definations */
/* --------------------------- */

struct list
{
	int data;
	struct list *next;
};

struct list *first;

/* Function Main Displays Menu */
/* --------------------------- */

void main(void)
{
	int ch=1,x;
	do
	{
		x=0;
		clrscr();
		window(1,1,30,30);
		printf("\n\n\n\tMerge Sort On Linked Lists");
		printf("\n\t--------------------------");
		printf("\n\t1.Create The List");
		printf("\n\t2.Sort The List");
		printf("\n\t3.Print The List");
		printf("\n\t4.Exit");
		printf("\n\t---------------------");
		printf("\n\tEnter Your Choice : ");
		printf("\n\t---------------------");
		gotoxy(28,11);
		printf("%d",ch);

		gotoxy(9,5+ch);
		textcolor(BLACK);
		textbackground(WHITE);
		cprintf(CHOICE(ch));

		while(x!=13)
		{
			fflush(stdin);
			x=getch();

			gotoxy(9,5+ch);
			textcolor(WHITE);
			textbackground(BLACK);
			cprintf(CHOICE(ch));

			if(x==80)
				ch=(ch < 4 ? ch+1 : 1);
			else if(x==72)
				ch=(ch > 1 ? ch-1 : 4);

			gotoxy(9,5+ch);
			textcolor(BLACK);
			textbackground(WHITE);
			cprintf(CHOICE(ch));
			gotoxy(28,11);
			printf("%d",ch);
		}

		window(1,1,85,25);
		textcolor(WHITE);
		textbackground(BLACK);

		switch(ch)
		{
			case 1:append();
				   break;
			case 2:first=sort(first);
				   break;
			case 3:print();
				   break;
		}
	}while(ch!=4);
	clrscr();
	return;
}

/* Function For Appending Elements In List */
/* --------------------------------------- */

void append(void)
{
	struct list *node,*last;
	int i,x,y;

	clrscr();
	printf("\n\n\tEnter The No. Of Elements:");
	x=scanf("%d",&y);
	if(x==0)
		return;

	while(first!=NULL)
	{
		last=first;
		first=first->next;
		last->next=NULL;
		free(last);
	}
	last=first;

	for(i=0;i<y;i++)
	{
		node=(struct list *)malloc(sizeof(struct list));
		printf("\n\tEnter The Data at %d Th Location:",i+1);
		fflush(stdin);
		x=scanf("%d",&node->data);

		while(x==0)
		{
			printf("\n\tInput Error!!! Enter Again:");
			fflush(stdin);
			x=scanf("%d",&node->data);
		}

		node->next=NULL;
		if(first==NULL)
			first=last=node;
		else
		{
			last->next=node;
			last=last->next;
		}
	}
	return;
}

/* Function For Displaying Linked List Elements */
/* -------------------------------------------- */

void print(void)
{
	struct list *temp;
	int i=1,j=1;
	temp=first;
	clrscr();
	printf("\n\n");

	if(temp==NULL)
		printf("\tList Is Empty Now!!!");

	while(temp!=NULL)
	{
		printf("\n\t%d %d",j,temp->data);
		temp=temp->next;
		i++;
		j++;
		if(i==21)
		{
			i=1;
			getch();
			clrscr();
			printf("\n\n");
		}
	}
	getch();
	return;
}

/* Function Sort Merge-Sorts The List */
/* ---------------------------------- */

struct list *sort(struct list *p)
{
	struct list *q,*head;

	clrscr();
	head=p;

	if(p!=NULL && p->next!=NULL)
	{
		q=divide(p);
		p=sort(p);
		q=sort(q);
		head=merge(p,q);
	}

	return(head);
}

/* Function Divide partitions The List in Two Sub List */
/* --------------------------------------------------- */

struct list *divide(struct list *p)
{
	struct list *q,*r;

	q=p;
	r=p->next->next;

	while(r!=NULL)
	{
		r=r->next;
		q=q->next;
		if(r!=NULL)
			r=r->next;
	}

	r=q->next;
	q->next=NULL;

	return(r);
}

/* Function Merge Combines The Two Given Lists */
/* ------------------------------------------- */

struct list *merge(struct list *p,struct list *q)
{
	struct list *head,*r;

	if(p==NULL || q==NULL)
		printf("merge called with empty list");

	if(p->data < q->data)
	{
		head=p;
		p=p->next;
	}
	else
	{
		head=q;
		q=q->next;
	}

	r=head;
	while(p!=NULL && q!=NULL)
		if(p->data < q->data)
		{
			r->next=p;
			r=r->next;
			p=p->next;
		}
		else
		{
			r->next=q;
			r=r->next;
			q=q->next;
		}

	if(p!=NULL)
		r->next=p;
	else
		r->next=q;

	return(head);
}