/* Conversion Of Postfix Expression To Infix Expression */
/* ---------------------------------------------------- */

/* Including Header Files */
/* ---------------------- */

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

/* Defining Function Prototypes */
/* ---------------------------- */

void ans(char *s);
int check(char *s);
void push(char *s);
char *pop(void);

/* Defining Stack As A Linked List */
/* ------------------------------- */

struct list
{
	char st[75];
	struct list *next;
} *first=NULL;

/* Function Main Manages Input & Output */
/* ------------------------------------ */

void main(void)
{
	char s[35],ch;
	int flag;
	do
	{
		clrscr();
		printf("\n\tEnter The Postfix Expression:\n\n\t");
		gets(s);
		flag=check(s);
		if(!flag)
			printf("\n\tError In Entering The Expression\a\a\a");
		else
			ans(s);

		printf("\n\tDo You Want To Continue(Y/N)?");

		do
			ch=getch();
		while(ch!='n' && ch!='N' && ch!='y' && ch!='Y');

	}while(ch!='n' && ch!='N');
	return;
}

/* Function Prints The Equivalent Infix Expression */
/* ----------------------------------------------- */

void ans(char *s)
{
	char a[75],a1[75],temp[2];
	while(*s!='\0')
	{
		temp[1]='\0';
		temp[0]=*s;
		if(*s=='*' || *s=='-' || *s=='+' || *s=='/' || *s=='^')
		{
			if(first==NULL)
			{
				printf("\n\tError In Entering The Expression:\a\a");
				return;
			}
			strcpy(a1,pop());
			strcpy(a,"(");
			if(first==NULL)
			{
				printf("\n\tError In Entering The Expression:\a\a\a");
				return;
			}
			strcat(a,pop());
			strcat(a,temp);
			strcat(a,a1);
			strcat(a,")");
			push(a);
		}
		else
			push(temp);
		s++;
	}

	if(first==NULL)
	{
		printf("\n\tError In Entering The Expression:\a\a\a");
		return;
	}
	strcpy(a,pop());
	printf("\n\tThe Required Expression Is:\n\n\t %s",a);
	return;
}

/* Function Check Will Tarce An Error If Any */
/* ----------------------------------------- */

int check(char *s)
{
	int var_count=0,opr_count=0;

	while((*s) != '\0')
	{
		if(*s=='*' || *s=='-' || *s=='+' || *s=='/' || *s=='^')
			opr_count++;
		else
			var_count++;
		s++;
	}

	return( (var_count-opr_count)==1?1:0 );
}

/* Function For Pushing To The Stack */
/* --------------------------------- */
void push(char *s)
{
	struct list *node;
	node=(struct list *)malloc(sizeof(struct list));
	node->next=first;
	strcpy(node->st,s);
	first=node;
	return;
}

/* Function For popping The Stack */
/* ------------------------------ */

char *pop(void)
{
	struct list *node;
	char st[75];

	node=first;
	first=first->next;
	node->next=NULL;
	strcpy(st,node->st);
	free(node);
	return(st);
}