	/* Program to implement primitive operations on
	   Sequential files. The input record contains :

		name of student,
		rollnumber and
		three test scores.


	   Program by : Mrs. Shivangi G. Potdar.			*/

/*----------------------------------------------------------------------*/
		/*Header Files*/
	#include<stdio.h>
	#include<conio.h>
	#include<stdlib.h>
	#include<string.h>

	/*structure declaration*/

	typedef struct record

	{
	  int roll,m1,m2,m3; /* m1,m2,m3 are the three test scores */
	  char name[30];
	}stud;

	FILE *fp;

	/*------------end of global variable declarations----------*/

	void display();
	void append();
	void create();
	void sort(FILE *);
	void display_one(stud ,int );
	void input_rec(FILE *);
	int search(char filename[]);
	void delete_rec(char filename[]);
	void index(char[]);
       /*----------Function prototype declaration ends------------*/

	main()
	{
	 char ans,filename[12];
	 int ch;
	 do
	 {
	   clrscr();
	   printf("\n\t\tINDEXED SEQUENTIAL FILE");
	   printf("\n\t 1>Create a file");
	   printf("\n\t 2>Add a record");
	   printf("\n\t 3>Search for Record");
	   printf("\n\t 4>Display file");
	   printf("\n\t 5>Quit");
	   printf("\n\t\t Enter your choice");
	   scanf("%d",&ch);
	   switch(ch)
	   {
	     case 1 :
		    clrscr();
		    create();
		    break;
	     case 2 :
		    clrscr();
		    append();
		    break;
	     case 3 :
		     clrscr();
		     printf("\nEnter the filename\n");
		     flushall();
		     gets(filename);
		     search(filename);
		     break;
	     case 4 :
		     clrscr();
		     display();
		     break;
	     case 5 :
		     clrscr();
		     exit(1);
		     break;
	     default:
		     printf("\nEntered wrong choice\n");
		     break;
	   }
		printf("\nDo you want to continue?[y/n]");
		flushall();
		ans = getch();
	 }while(ans == 'y' || ans == 'Y');
	}
/*-----------------End of main function-----------------------------*/

	void create()
	/*Function to create a new file*/
	{
	 char filename[12];
	 printf("\n\tEnter the filename in which you wish to store data\n");
	 flushall();
	 gets(filename);
	 if((fp = fopen(filename,"wb")) == NULL)
	 {
		printf("ERROR in opening file in write mode");
		return;
	 }
	 input_rec(fp); /* get records in file */
	 fclose(fp);
	 if((fp = fopen(filename,"rb+")) == NULL)
	 {
		printf("Error in opening file in read mode");
		return;
	 }
	}

/*------------End of function create---------------------------------*/

	void input_rec(FILE *fp)

	/*Accept data for record*/

	{
	 stud temp;
	 char ch;
	 int i = 1;
	 do
	 {
		clrscr();
		printf("\n\n\tRecord No. %d",i);
		printf("\n\n\tStudent Name :");
		fflush(stdin);
		gets(temp.name);
		printf("\n\n\tRoll number :");
		scanf("%d",&temp.roll);
		printf("\n\n\tMarks 1 :");
		scanf("%d",&temp.m1);
		printf("\n\n\tMarks 2 :");
		scanf("%d",&temp.m2);
		printf("\n\n\tMarks 3 :");
		scanf("%d",&temp.m3);
		fwrite(&temp,sizeof(stud),1,fp);
		i++;
		printf("\nDo you wish to continue adding records?[y/n]");
		flushall();
		ch = getch();

	 }while(ch == 'y' || ch == 'Y');

	}


/*---------------End of function input_rec---------------------------*/


	void append()

	/*Appending the exisiting file*/

	{
	 char filename[12];
	 printf("\nEnter the filename\n");
	 flushall();
	 gets(filename);
	 if((fp = fopen(filename,"ab")) == NULL)
	 {
		printf("ERROR in opening file");
		return;
	 }
	 printf("\nAppending File");
	 getch();
	 input_rec(fp);
	 fclose(fp);
	 if((fp = fopen(filename,"rb+")) == NULL)
	 {
		printf("Error in opening file");
		return;
	 }
	}

/*----------------end of append function----------------------------*/

	void display()

	/*displaying the file*/

	{
	 char filename[12];
	 int i = 1;
	 stud temp;
	 printf("\nEnter the filename\n");
	 flushall();
	 gets(filename);
	 if((fp = fopen(filename,"rb")) == NULL)
	 {
	   printf("\nError in opening file");
	   return;
	 }
	    fread(&temp,sizeof(stud),1,fp);
	 while(!feof(fp))
	 {
	    clrscr();

		printf("\nRecords of file '%s'",filename);
		printf("\n\n\tRecord   %d",i);
		printf("\n\n\tStudent Name : %s",temp.name);
		printf("\n\n\tRoll Number : %d",temp.roll);
		printf("\n\n\tMarks 1 : %d",temp.m1);
		printf("\n\n\tMarks 2 : %d",temp.m2);
		printf("\n\n\tMarks 3 : %d",temp.m3);
		i++;
		getch();
		 fread(&temp,sizeof(stud),1,fp);
		printf("Enter to continue....");
	}
	fclose(fp);
		}
/*---------------------------End of function DISPLAY----------------*/

	int search(char filename[])

	/*searching for required record*/

	{
	 int found=0,rno,key,pos = 0,kk;
	 stud temp;
	 if((fp = fopen(filename,"rb")) == NULL)
	 {
		printf("\nError in opening File");
		return;
	 }
	 printf("\nEnter The roll number of record to be found\n");
	 scanf("%d",&rno);
	 while((!found)&&(!feof(fp)))
	 {
		    fread(&temp,sizeof(stud),1,fp);
		if(temp.roll == rno)  /* get the record for required key */
			found = 1;
	 }
	 if(found == 1)
	 {
		display_one(temp,pos);
		return(pos);
	 }
	 else
	 {
		printf("\nRecord not found");
		 fclose(fp);
		return(-1);
	 }
	}
/*---------------End of search function-----------------------------*/

	void display_one(stud temp,int pos)

	/*display the record which "search" function has
	  found                  */

	{
	 clrscr();
	 printf("\n\n\tRecord   %d",pos);
	 printf("\n\n\tStudent Name : %s",temp.name);
	 printf("\n\n\tRoll Number : %d",temp.roll);
	 printf("\n\n\tMarks 1 : %d",temp.m1);
	 printf("\n\n\tMarks 2 : %d",temp.m2);
	 printf("\n\n\tMarks 3 : %d",temp.m3);
	 getch();
	 printf("Enter to continue....");
	}

/*---------------End of display function of single record------------*/










