	/* Program to find the shortest path between a pair of
	   nodes in weighted graph,using Dijkstra's algo.

	    Program by :Mrs. Shivangi G. Potdar.               */

		#include<stdio.h>
		#include<stdlib.h>
		#define member 1 /* used to indicate current node
				    which has become working node */

		#define nonmember 0 /* indicates node not prcessed */

		#define infinity 999 /* initial distance */

		struct arc
		{
		   int wt;
		};
		struct arc g[10][10]; /* struct to hold the graph */
		int path[10];
	/*--------------End of global definitions--------------------*/

	void joinwt(struct arc g[][10],int node1,int node2,int wt)
	/* function to assign the weights on arcs */
	{
	   g[node1][node2].wt=wt; /* assign the weight to arc node1-node2*/
	}

/*-------------end of function joinwt---------------------------------*/

	cost (struct arc c[][10],int n)
	/* function to get the weights */
	{
	  int i,j,wt;
	  for(i=0;i<n;i++)
	  for(j=0;j<n;j++)
	  {
	   printf("\n weight of arc %d %d",i,j);
	   scanf("%d",&wt);
	   joinwt(c,i,j,wt);
	  }
	  printf("\n");
	}
/*-------------------End of function-------------------------------*/
	mat(struct arc a[][10],int n)
	/* function to print the weight matrix */
	{
	  int i,j;
	  printf("\n\t");
	  for(i=0;i<n;i++)
	  {
	   for(j=0;j<n;j++)
	   {
	    printf("%d      ",a[i][j].wt);
	   }
	    printf("\n\t");
	  }
	}
/*-------------------End of function mat--------------------------*/
	shortpath(wt,s,t,preced,n)
	   struct arc wt[][10];
	   int s,t,preced[10];
	   int n;
	{
	  int dist[10],perm[10];
	  int curr,i,k,dc,h=0;
	  int smalldist,newdist;
	  for(i=0;i<n;i++) /* initialise */
	  {
	   perm[i]=nonmember;  /* no node is prcessed */
	   dist[i]=infinity;  /* initial distance is infinity */
	  }
	  perm[s]=member; /* start from 's' */
	  dist[s]=0;
	  curr=s; /* working node is curr */
	  while(curr!=t) /* till we are not at destination */
	  {
	    smalldist=infinity;
	    dc=dist[curr];
	    for(i=0;i<n;i++)
	    if(perm[i]==nonmember) /* find smallest distance from current
				      working node */
	    {
	     newdist=dc+wt[curr][i].wt;
	     if(newdist<dist[i])
	     {
	       dist[i]=newdist;
	       preced[i]=curr;
	     }
	    if(dist[i]<smalldist)
	    {
	      smalldist=dist[i];
	      k=i;
	    }
	   }
	   curr=k;
	   perm[curr]=member;
	   path[h++]=curr;
	 }

	 printf("\n\tPATH IS = %d",s+1); /* print the path */
	 for(i=0;i<h;i++)
	 printf(" ----> %d ",(path[i]+1));
	 return(dist[t]);
	}
/*-----------------End of function shortpath---------------------*/

	main()
	{
	  struct arc c[10][10];
	  int n,s,t,preced[10];
	  int x;
	  clrscr();
	  printf("\n\t\t How many nodes :");
	  scanf("%d",&n);
	  printf("\n\t\t Enter the adjacency matrix of weight ");
	  printf("\n\t\t Enter 999 if no edge exists :");
	  cost(c,n);
	  clrscr();
	  printf("\n weight matrix :");
	  mat(c,n);
	  printf("\n ENTER SOURCE AND DESTINATION ");
	  scanf("%d %d",&s,&t);
	  printf("\t\tShortest PATH BETWEEN  %d AND   %d IS: \n",s,t);
	  x=shortpath(c,s-1,t-1,preced,n);
	  printf("\n The path length is %d",x);
	}
/*---------------------End of main----------------------------------*/